#!/bin/sh

# Bugfix TP #97785.
# Set correct permissions on the php session path

php_ini_list="/etc/php.ini /etc/php5/apache2/php.ini \
			/etc/php5/cli/php.ini /etc/php5/fastcgi/php.ini /etc/php5/cgi/php.ini"

set_php_session_save_path_perms()
{
	local php_ini="$1"

	[ -r "$php_ini" ] || return

	if [ -n "$php_ini" -a -L "$php_ini" ]; then
		php_ini=`realpath $php_ini`
	fi

	ssave_path=`php -c "$php_ini" -r "echo ini_get('session.save_path');" 2>/dev/null || get_phpini_var "session.save_path"`
	[ -n "$ssave_path" -a -d "$ssave_path" -a "$ssave_path" != "/tmp" ] || return

	# detect apache user/group by OS
	# Debian www-data:www-data 
	# Ubuntu www-data:www-data 
	# SuSE   wwwrun:www
	# RedHat apache:apache

	os=''
	for f in redhat-release SuSE-release lsb-release debian_version; do
		if [ -f "/etc/$f" ]; then
			os="$f"
			break
		fi
	done

	case $os in
		redhat-release)
			user="apache"
			group="apache"
		;;
		SuSE-release)
			user="wwwrun"
			group="www"
		;;
		lsb-release|debian_version)
			user="www-data"
			group="www-data"
		;;
		*) 
			user="root"
			group="root"
		;;
	esac

	chown $user:psacln $ssave_path
	chmod 0770 $ssave_path
}

[ -f "/usr/local/psa/tmp/mu_session_installed.flag" ] && exit 0

for i in $php_ini_list; do
	set_php_session_save_path_perms $i
done

touch /usr/local/psa/tmp/mu_session_installed.flag

exit 0
